# LinkeDS

This project introduces a versatile implementation of linked data structures, encompassing stacks, queues, and linked lists. The structures are designed for 
adaptability, available in both bounded and dynamic size variations. Single and doubly linked nodes facilitate flexible element connections.

Incorporating advanced features, the project includes a Jsonifier class, which acts as an Abstract Base Class (ABC) for JSON serialization and deserialization. 
This comprehensive toolkit empowers developers with efficient and flexible linked data structures, suitable for diverse programming needs.

> [!NOTE]  
> This project has been developed based on Python 3.6 or above.

<br />



## Features

1. **Bounded and Dynamic Sizes**: Choose between bounded and dynamic sizes for each structure, offering flexibility in managing element capacity.
2. **Single and Doubly Linked Nodes**: Utilize both single and doubly linked nodes to facilitate versatile connections between elements.
3. **Efficient Stack Operations**: Execute all standard operations for each data structure, including bounded and dynamic sizes.
4. **Serialization of List**: Serialize the entire list effortlessly to JSON format, enabling easy persistence and interchangeability.

<br />



## License

This project adopts the **MIT License**, which allows you to use and make modifications to the code as you wish. The only thing I ask is that proper credit is given, acknowledging the effort and time I invested in building it.